]>
Commit | Line | Data |
---|---|---|
67326666 JP |
1 | #!/bin/bash |
2 | # | |
3 | # Translate stack dump function offsets. | |
4 | # | |
5 | # addr2line doesn't work with KASLR addresses. This works similarly to | |
6 | # addr2line, but instead takes the 'func+0x123' format as input: | |
7 | # | |
8 | # $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568 | |
9 | # meminfo_proc_show+0x5/0x568: | |
10 | # meminfo_proc_show at fs/proc/meminfo.c:27 | |
11 | # | |
12 | # If the address is part of an inlined function, the full inline call chain is | |
13 | # printed: | |
14 | # | |
15 | # $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27 | |
16 | # native_write_msr+0x6/0x27: | |
17 | # arch_static_branch at arch/x86/include/asm/msr.h:121 | |
18 | # (inlined by) static_key_false at include/linux/jump_label.h:125 | |
19 | # (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125 | |
20 | # | |
21 | # The function size after the '/' in the input is optional, but recommended. | |
22 | # It's used to help disambiguate any duplicate symbol names, which can occur | |
23 | # rarely. If the size is omitted for a duplicate symbol then it's possible for | |
24 | # multiple code sites to be printed: | |
25 | # | |
26 | # $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5 | |
27 | # raw_ioctl+0x5/0x20: | |
28 | # raw_ioctl at drivers/char/raw.c:122 | |
29 | # | |
30 | # raw_ioctl+0x5/0xb1: | |
31 | # raw_ioctl at net/ipv4/raw.c:876 | |
32 | # | |
33 | # Multiple addresses can be specified on a single command line: | |
34 | # | |
35 | # $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90 | |
36 | # type_show+0x10/0x2d: | |
37 | # type_show at drivers/video/backlight/backlight.c:213 | |
38 | # | |
39 | # free_reserved_area+0x90/0x123: | |
40 | # free_reserved_area at mm/page_alloc.c:6429 (discriminator 2) | |
41 | ||
42 | ||
43 | set -o errexit | |
44 | set -o nounset | |
45 | ||
46 | command -v awk >/dev/null 2>&1 || die "awk isn't installed" | |
47 | command -v readelf >/dev/null 2>&1 || die "readelf isn't installed" | |
48 | command -v addr2line >/dev/null 2>&1 || die "addr2line isn't installed" | |
49 | ||
50 | usage() { | |
51 | echo "usage: faddr2line <object file> <func+offset> <func+offset>..." >&2 | |
52 | exit 1 | |
53 | } | |
54 | ||
55 | warn() { | |
56 | echo "$1" >&2 | |
57 | } | |
58 | ||
59 | die() { | |
60 | echo "ERROR: $1" >&2 | |
61 | exit 1 | |
62 | } | |
63 | ||
64 | # Try to figure out the source directory prefix so we can remove it from the | |
65 | # addr2line output. HACK ALERT: This assumes that start_kernel() is in | |
66 | # kernel/init.c! This only works for vmlinux. Otherwise it falls back to | |
67 | # printing the absolute path. | |
68 | find_dir_prefix() { | |
69 | local objfile=$1 | |
70 | ||
71 | local start_kernel_addr=$(readelf -sW $objfile | awk '$8 == "start_kernel" {printf "0x%s", $2}') | |
72 | [[ -z $start_kernel_addr ]] && return | |
73 | ||
74 | local file_line=$(addr2line -e $objfile $start_kernel_addr) | |
75 | [[ -z $file_line ]] && return | |
76 | ||
77 | local prefix=${file_line%init/main.c:*} | |
78 | if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then | |
79 | return | |
80 | fi | |
81 | ||
82 | DIR_PREFIX=$prefix | |
83 | return 0 | |
84 | } | |
85 | ||
86 | __faddr2line() { | |
87 | local objfile=$1 | |
88 | local func_addr=$2 | |
89 | local dir_prefix=$3 | |
90 | local print_warnings=$4 | |
91 | ||
92 | local func=${func_addr%+*} | |
93 | local offset=${func_addr#*+} | |
94 | offset=${offset%/*} | |
95 | local size= | |
96 | [[ $func_addr =~ "/" ]] && size=${func_addr#*/} | |
97 | ||
98 | if [[ -z $func ]] || [[ -z $offset ]] || [[ $func = $func_addr ]]; then | |
99 | warn "bad func+offset $func_addr" | |
100 | DONE=1 | |
101 | return | |
102 | fi | |
103 | ||
104 | # Go through each of the object's symbols which match the func name. | |
105 | # In rare cases there might be duplicates. | |
106 | while read symbol; do | |
107 | local fields=($symbol) | |
efdb4167 JP |
108 | local sym_base=0x${fields[0]} |
109 | local sym_type=${fields[1]} | |
110 | local sym_end=0x${fields[3]} | |
111 | ||
112 | # calculate the size | |
113 | local sym_size=$(($sym_end - $sym_base)) | |
114 | if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then | |
115 | warn "bad symbol size: base: $sym_base end: $sym_end" | |
116 | DONE=1 | |
117 | return | |
118 | fi | |
119 | sym_size=0x$(printf %x $sym_size) | |
67326666 JP |
120 | |
121 | # calculate the address | |
122 | local addr=$(($sym_base + $offset)) | |
123 | if [[ -z $addr ]] || [[ $addr = 0 ]]; then | |
124 | warn "bad address: $sym_base + $offset" | |
125 | DONE=1 | |
126 | return | |
127 | fi | |
efdb4167 | 128 | addr=0x$(printf %x $addr) |
67326666 JP |
129 | |
130 | # weed out non-function symbols | |
efdb4167 | 131 | if [[ $sym_type != t ]] && [[ $sym_type != T ]]; then |
67326666 | 132 | [[ $print_warnings = 1 ]] && |
efdb4167 | 133 | echo "skipping $func address at $addr due to non-function symbol of type '$sym_type'" |
67326666 JP |
134 | continue |
135 | fi | |
136 | ||
137 | # if the user provided a size, make sure it matches the symbol's size | |
138 | if [[ -n $size ]] && [[ $size -ne $sym_size ]]; then | |
139 | [[ $print_warnings = 1 ]] && | |
efdb4167 | 140 | echo "skipping $func address at $addr due to size mismatch ($size != $sym_size)" |
67326666 JP |
141 | continue; |
142 | fi | |
143 | ||
144 | # make sure the provided offset is within the symbol's range | |
145 | if [[ $offset -gt $sym_size ]]; then | |
146 | [[ $print_warnings = 1 ]] && | |
efdb4167 | 147 | echo "skipping $func address at $addr due to size mismatch ($offset > $sym_size)" |
67326666 JP |
148 | continue |
149 | fi | |
150 | ||
151 | # separate multiple entries with a blank line | |
152 | [[ $FIRST = 0 ]] && echo | |
153 | FIRST=0 | |
154 | ||
efdb4167 JP |
155 | # pass real address to addr2line |
156 | echo "$func+$offset/$sym_size:" | |
157 | addr2line -fpie $objfile $addr | sed "s; $dir_prefix\(\./\)*; ;" | |
67326666 JP |
158 | DONE=1 |
159 | ||
efdb4167 | 160 | done < <(nm -n $objfile | awk -v fn=$func '$3 == fn { found=1; line=$0; start=$1; next } found == 1 { found=0; print line, $1 }') |
67326666 JP |
161 | } |
162 | ||
163 | [[ $# -lt 2 ]] && usage | |
164 | ||
165 | objfile=$1 | |
166 | [[ ! -f $objfile ]] && die "can't find objfile $objfile" | |
167 | shift | |
168 | ||
169 | DIR_PREFIX=supercalifragilisticexpialidocious | |
170 | find_dir_prefix $objfile | |
171 | ||
172 | FIRST=1 | |
173 | while [[ $# -gt 0 ]]; do | |
174 | func_addr=$1 | |
175 | shift | |
176 | ||
177 | # print any matches found | |
178 | DONE=0 | |
179 | __faddr2line $objfile $func_addr $DIR_PREFIX 0 | |
180 | ||
181 | # if no match was found, print warnings | |
182 | if [[ $DONE = 0 ]]; then | |
183 | __faddr2line $objfile $func_addr $DIR_PREFIX 1 | |
184 | warn "no match for $func_addr" | |
185 | fi | |
186 | done |